#ifndef AI_H
#define AI_H

using namespace std;

bool compare(int arr1[], int arr2[], int arr3[])
{
    for(int i = 0; i < 8; i++)
        if(arr1[i] != arr2[i] || arr1[i] != arr3[i])
            return false;

    return true;
}

bool compare(int arr1[], int arr2[])
{
    for(int i = 0; i < 8; i++)
        if(arr1[i] != arr2[i])
            return false;

    return true;
}

int listPossibleMoves(piece *sq[8][8], int playerTurn,  int moveList[100][6])
{
    int moveNum = 0;
    for(int r = 0; r < 8; r++)
        for(int c = 0; c < 8; c++)
            if(sq[r][c] != NULL)
                if(sq[r][c]->getPlayer() == playerTurn)
                {
                    moveNum = sq[r][c]->possibleMoves(r, c, sq, moveList, moveNum);
                }
    return moveNum;
}

void makeMove(int moveList[100][6], int moveNum, piece *sq[8][8])
{

    int sRow = moveList[moveNum][0],
        sCol = moveList[moveNum][1],
        dRow = moveList[moveNum][2],
        dCol = moveList[moveNum][3];

    if(dRow != 9)
    {
        sq[dRow][dCol] = sq[sRow][sCol];
        sq[sRow][sCol] = NULL;
    }
    else
    {
        if(dCol == 0)       //Short Castle
        {
            sq[sRow][6] = sq[sRow][4];
            sq[sRow][5] = sq[sRow][7];
            sq[sRow][7] = NULL;
        }
        else                // Long Castle
        {
            sq[sRow][2] = sq[sRow][4];
            sq[sRow][3] = sq[sRow][0];
            sq[sRow][0] = NULL;
        }

        sq[sRow][4] = NULL;
    }
}

piece *createPiece(int playerTurn, int code)
{
    char colour;
    piece *newPiece;
    if(playerTurn == 0)
        colour = 'W';
    else
        colour = 'B';

    switch(code)
    {
        case 0:
            newPiece = new king(colour, playerTurn);
            break;
        case 1:
            newPiece = new pawn(colour, playerTurn);
            break;
        case 2:
            newPiece = new knight(colour, playerTurn);
            break;
        case 3:
            newPiece = new bishop(colour, playerTurn);
            break;
        case 5:
            newPiece = new rook(colour, playerTurn);
            break;
        case 9:
            newPiece = new queen(colour, playerTurn);
            break;

    }

    return newPiece;

}

void undoMove(int moveList[100][6], int moveNum, piece *sq[8][8])
{
    int sRow = moveList[moveNum][0],
        sCol = moveList[moveNum][1],
        dRow = moveList[moveNum][2],
        dCol = moveList[moveNum][3];

    if(dRow != 9)
    {
        sq[sRow][sCol] = sq[dRow][dCol];
        if(moveList[moveNum][4] == -1)
            sq[dRow][dCol] = NULL;
        else
        {
            sq[dRow][dCol] = createPiece(moveList[moveNum][4], moveList[moveNum][5]);
        }
    }
    else
    {
        if(dCol == 0)       //Short Castle
        {
            sq[sRow][4] = sq[sRow][6];
            sq[sRow][7] = sq[sRow][5];
            sq[sRow][5] = NULL;
            sq[sRow][6] = NULL;
        }
        else                // Long Castle
        {
            sq[sRow][4] = sq[sRow][2];
            sq[sRow][0] = sq[sRow][3];
            sq[sRow][3] = NULL;
            sq[sRow][2] = NULL;
        }

    }


}

int evaluate(piece *sq[8][8])
{
    int blackSum = 0, whiteSum = 0;
    for(int r = 0; r < 8; r++)
    {
        for(int c = 0; c < 8; c++)
        {
            if(sq[r][c] != NULL)
            {
                if(sq[r][c]->getColor() == 'W')
                {
                    whiteSum += sq[r][c]->getValue() + sq[r][c]->getPTable(7-r, c, sq);
                }
                else
                {
                    blackSum += sq[r][c]->getValue() + sq[r][c]->getPTable(r, c, sq);
                }
            }
        }
    }

    return (blackSum - whiteSum);
}

struct Node
{
    int listOfMoves[100][6];
    int numMoves;
    int alpha, beta;
    int type;       //MAX - 1, MIN - 0
    float value;
    int childValue[100];
    bool endNode;
    Node *in;
    Node *out;
};

int getValue(Node &n, piece *sq[8][8], int moveHistory[5][8])
{
    if(n.endNode == false)
    {
        n.numMoves = listPossibleMoves(sq, n.type, n.listOfMoves);

        if(n.numMoves == 0)
        {
            if(check(n.type, sq) == true){
                if(n.type==1){
                    return -100000;
                }
                else{
                    return 100000;
                }
            }
            else if(check(1-n.type,sq)){
                if(n.type==1)
                    return 100000;
                else
                    return -100000;
            }
            else
                return 0;
        }

        for(int i = 0; i < n.numMoves; i++)
        {


            if(n.in == NULL )
            {
                for(int j = 0; j < 4; j++)
                    moveHistory[4][j+4] = n.listOfMoves[i][j];
                n.out->alpha = n.alpha;
                n.out->beta = n.beta;
                if(compare(moveHistory[1], moveHistory[3]) == true &&       //Check for three-fold repetition
                compare(moveHistory[0], moveHistory[2], moveHistory[4]) == true)
                {
                    n.childValue[i] = 0;
                }
                else
                if((n.listOfMoves[i][0] == ((n.type == 0) ? 1 : 6)) && (n.listOfMoves[i][2] == ((n.type == 0) ? 0 : 7))
                    && sq[n.listOfMoves[i][0]][n.listOfMoves[i][1]]->getName() == 'P')
                {
                        n.childValue[i] = 10000;
                }
                else
                {
                    makeMove(n.listOfMoves, i, sq);
                    n.out->alpha = n.alpha;
                    n.out->beta = n.beta;
                    n.childValue[i] = getValue(*(n.out), sq, moveHistory);
                    undoMove(n.listOfMoves, i, sq);
                }

                for(int j = 0; j < 4; j++)
                    moveHistory[4][j+4] = 0;

            }
            else
            {
                makeMove(n.listOfMoves, i, sq);
                n.out->alpha = n.alpha;
                n.out->beta = n.beta;
                n.childValue[i] = getValue(*(n.out), sq, moveHistory);
                undoMove(n.listOfMoves, i, sq);
            }

            if(n.type == 1)
            {
                n.alpha = max(n.alpha, n.childValue[i]);
            }
            else
            {
                n.beta = min(n.beta, n.childValue[i]);
            }

            if(n.alpha > n.beta)
            {
                if(n.type == 1)
                {    n.value = findMax(n.childValue, i+1);
                    return (n.value - 0.1);
                }
                else
                {
                    n.value = findMin(n.childValue, i+1);
                    return (n.value + 0.1);
                }
            }
        }

        if(n.type == 1)
            n.value = findMax(n.childValue, n.numMoves);
        else
            n.value = findMin(n.childValue, n.numMoves);
        return n.value;
    }
    else
    {
        n.value = evaluate(sq);
        return n.value;
    }

}

void getCompMove(int move[], piece *sq[8][8], int moveHistory[5][8])
{
    int nodeListSize;
    Node *A;
    if(sumPieceValues(sq) > 41500)
        nodeListSize = 5;
    else
        nodeListSize = 7;

    A = new Node [nodeListSize];
    A[0].type = 1-human;
    for(int i = 0 ; i < nodeListSize-1; i++)
    {
        A[i].endNode = false;
        A[i].alpha = -1000000;
        A[i].beta = 1000000;
        if(i)
            A[i].type = 1 - A[i-1].type;

        A[i].out = &A[i+1];
        if(i)
            A[i].in = &A[i-1];
        else
            A[i].in = NULL;
    }

    A[nodeListSize-1].in = &A[nodeListSize-2];
    A[nodeListSize-1].out = NULL;
    A[nodeListSize-1].endNode = true;

    int maxValue = getValue(A[0], sq, moveHistory);
    int maxValIndex;
    for(maxValIndex = 0; A[0].childValue[maxValIndex] != maxValue; maxValIndex++)
    {}
    move[0] = A[0].listOfMoves[maxValIndex][1];
    move[1] = A[0].listOfMoves[maxValIndex][0];
    move[2] = A[0].listOfMoves[maxValIndex][3];
    move[3] = A[0].listOfMoves[maxValIndex][2];
}

#endif // AI_H
