#include<iostream>
#include <SDL2/SDL.h>
#include "structures.h"
bool reset=false;
bool quit=false;
int human=0;
//The function that actually prints the board
void gprint(piece* sq[8][8]);

#include "ai.h"

#include "graphics.h"

using namespace std;


piece *sq[8][8];
void game()
{
    sq[0][0] = new rook('B', 1);
    sq[0][1] = new knight('B', 1);
    sq[0][2] = new bishop('B', 1);
    sq[0][3] = new queen('B', 1);
    sq[0][4] = new king('B', 1);
    sq[0][5] = new bishop('B', 1);
    sq[0][6] = new knight('B', 1);
    sq[0][7] = new rook('B', 1);
    for(int i = 0; i < 8; i++)
        sq[1][i] = new pawn('B', 1);

    sq[7][0] = new rook('W', 0);
    sq[7][1] = new knight('W', 0);
    sq[7][2] = new bishop('W', 0);
    sq[7][3] = new queen('W', 0);
    sq[7][4] = new king('W', 0);
    sq[7][5] = new bishop('W', 0);
    sq[7][6] = new knight('W', 0);
    sq[7][7] = new rook('W', 0);
    for(int i = 0; i < 8; i++)
        sq[6][i] = new pawn('W', 0);

    for(int i = 2; i < 6; i++)
        for(int  j = 0; j < 8; j++)
            sq[i][j] = NULL;
    /*for(int i = 2; i < 8; i++)
        for(int  j = 0; j < 8; j++)
            sq[i][j] = NULL;
    sq[0][1]=new king('W',0);
    sq[1][0]=new pawn('W',0);
    sq[7][6]=new king('B',1);
    sq[6][7]=new pawn('B',1);*/
    human=ShowMessage("Chess","Welcome to a game of 1-Player Chess. Do you want to play as white or black?","Black","White");
    bool gameOver = false, validMove = false, checkTrue = false;
    int playerTurn = 0;    //White starts
    int move[4]={0};
    int sRow, sCol, dRow, dCol;

    int moveHistory[5][8] = {{-1, -1, -1, -1, -1, -1, -1, -1},
                             {-1, -1, -1, -1, -1, -1, -1, -1},
                             {-1, -1, -1, -1, -1, -1, -1, -1},
                             {-1, -1, -1, -1, -1, -1, -1, -1},
                             {-1, -1, -1, -1, -1, -1, -1, -1}};
    while(!gameOver)
    {
        printBoard(sq);
        if(playerTurn==human){
            if(moveHistory[4][4]!=-1){
                SDL_Rect d1;
                SDL_Rect d2;
                d1.x=13+50*moveHistory[4][5];
                d1.y=37+50*moveHistory[4][4];
                d2.x=13+50*moveHistory[4][7];
                d2.y=37+50*moveHistory[4][6];
                SDL_BlitSurface(lm,NULL,gScreenSurface,&d1);
                SDL_BlitSurface(lm,NULL,gScreenSurface,&d2);
            }
            SDL_UpdateWindowSurface(gWindow);
        }

        do{
            getMove(move, playerTurn, sq, moveHistory);
            sCol = move[0];
            sRow = move[1];
            dCol = move[2];
            dRow = move[3];
            //QUIT condition
            if(move[0]==-1){
                return;
            }

            validMove = sq[sRow][sCol]->validate(sRow, sCol, dRow, dCol, sq);

            if(!validMove)
            {
                SDL_ShowSimpleMessageBox(SDL_MESSAGEBOX_INFORMATION,"Invalid Move","Your move is not valid.",NULL);
                gprint(sq);
                continue;
            }

            //4709/4009 = Short Castle, 4719/4019 - Long Castle

            if(dRow == 9)
            {
                if(dCol == 0)       //Short Castle
                {
                    sq[sRow][6] = sq[sRow][4];
                    sq[sRow][5] = sq[sRow][7];
                    sq[sRow][7] = NULL;
                }
                else                // Long Castle
                {
                    sq[sRow][2] = sq[sRow][4];
                    sq[sRow][3] = sq[sRow][0];
                    sq[sRow][0] = NULL;
                }

                sq[sRow][4] = NULL;
            }
            else
            {
                        piece *temp = sq[dRow][dCol];
                        sq[dRow][dCol] = sq[sRow][sCol];
                        sq[sRow][sCol] = NULL;

                        if(check(playerTurn, sq))
                        {
                            SDL_ShowSimpleMessageBox(SDL_MESSAGEBOX_INFORMATION,"Invalid Move","Your move is not valid. Your king falls under a check!",NULL);
                            sq[sRow][sCol] = sq[dRow][dCol];
                            sq[dRow][dCol] = temp;
                            gprint(sq);

                            validMove = false;
                            continue;
                        }

                        if(dRow ==playerTurn*7){
                            if(sq[dRow][dCol]->getName()=='P'){
                                delete sq[dRow][dCol];
                                if(playerTurn==human){
                                    gPromote(dRow,dCol,sq,playerTurn);
                                }
                                else{
                                    sq[dRow][dCol]=new queen((human==0)?('B'):('W'),1-human);
                                }
                            }
                        }

                if(temp!=NULL){
                delete temp;
                }
            }


        }while(validMove == false);

        if(dRow != 9)
        {
            if(sq[dRow][dCol]->getHasMoved() == false)
            {
                sq[dRow][dCol]->moved();        //hasMoved = true
            }
        }

        if(playerTurn == human)
        {
            for(int i = 0; i < 4; i++)
            {
                for(int j = 0; j < 8; j++)
                    moveHistory[i][j] = moveHistory[i+1][j];
            }

            for(int i = 0; i < 4; i++)
                moveHistory[4][i+4*(1-human)] = 0;
        }
        moveHistory[4][mod(human-playerTurn)*4 + 0] = sRow;
        moveHistory[4][mod(human-playerTurn)*4 + 1] = sCol;
        moveHistory[4][mod(human-playerTurn)*4 + 2] = dRow;
        moveHistory[4][mod(human-playerTurn)*4 + 3] = dCol;

        playerTurn = 1 - playerTurn;
        if(check(playerTurn, sq))
        {
            if(checkmate(playerTurn,sq))
            {
                printBoard(sq);
                if(playerTurn == 1){
                    SDL_ShowSimpleMessageBox(SDL_MESSAGEBOX_INFORMATION,"Game Over","Checkmate. White wins",NULL);
                }
                else{
                     SDL_ShowSimpleMessageBox(SDL_MESSAGEBOX_INFORMATION,"Game Over","Checkmate. Black wins",NULL);
                }
                gameOver = true;

            }
            else
                checkTrue = true;
        }
        else
        if(checkmate(playerTurn,sq))
        {
            printBoard(sq);
            SDL_ShowSimpleMessageBox(SDL_MESSAGEBOX_INFORMATION,"Game Over","Stalemate. Draw",NULL);
            gameOver = true;
        }
        else if(compare(moveHistory[0],moveHistory[2],moveHistory[4])&&compare(moveHistory[1],moveHistory[3])){
            printBoard(sq);
            SDL_ShowSimpleMessageBox(SDL_MESSAGEBOX_INFORMATION,"Game Over","Threefold Repetition. Draw",NULL);
            gameOver = true;
        }
        if(reset==true){
            return;
        }
    }
}
void clear(){
    for(int i=0; i<8; i++){
        for(int j=0;j<8;j++){
            if(sq[i][j]!=NULL){
                delete sq[i][j];
            }
        }
    }
}

int main(int argc, char* args[] )
{
    initialize();
    again:game();
    clear();
    if(reset==true){
            reset=false;
            goto again;
    }
    if(quit==false){
        if(ShowMessage("Chess","Play another game of chess?","Yes","No")==1){
            goto again;
        }
    }
    close();
    return 0;
}
