#include<iostream>
#include "structures.h"
using namespace std;

bool attack(int playerTurn, piece *sq[8][8], int row, int col)
{
    for(int i = 0; i < 8; i++)
    {
        for(int j = 0; j < 8; j++)
        {
            if(sq[i][j] != NULL)
            {
                if(playerTurn != sq[i][j]->getPlayer())
                   {
                        if(sq[i][j]->validate(i, j, row, col, sq) == true)
                        {
                            return true;
                        }
                   }
            }
        }
    }

    return false;
}

rook::rook(char colour, int p){
    name='R';
    color=colour;
    hasMoved=false;
    player=p;
    return;
}

bool rook::getHasMoved(){
    return hasMoved;
}

void rook::moved(){
    hasMoved = true;
    return;
}

bool rook::validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
    if(!(sRow==dRow||sCol==dCol)){
        return false;
    }
    if(sRow<dRow){
        for(int i=sRow+1;i<dRow;i++){
            if(!(sq[i][sCol]==NULL)){
                return false;
            }
        }
    }
    else if(sRow>dRow){
        for(int i=dRow+1;i<sRow;i++){
            if(!(sq[i][sCol]==NULL)){
                return false;
            }
        }
    }
    if(sCol<dCol){
        for(int i=sCol+1;i<dCol;i++){
            if(!(sq[sRow][i]==NULL)){
                return false;
            }
        }
    }
    else if(dCol<sCol){
        for(int i=dCol+1;i<sCol;i++){
            if(!(sq[sRow][i]==NULL)){
                return false;
            }
        }
    }
    if(sq[dRow][dCol] != NULL)
        if(sq[dRow][dCol]->getColor()==color)
            return false;

    return true;
}

bishop::bishop(char colour, int p){
    color=colour;
    name='B';
    hasMoved=false;
    player=p;
}

bool bishop::getHasMoved(){
    return hasMoved;
}

void bishop::moved(){
    hasMoved = true;
    return;
}

bool bishop::validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
    if(!(((sRow-dRow)==(sCol-dCol))||((dRow-sRow)==(sCol-dCol)))){
        return false;
    }
    int r=((sRow<dRow)?(1):(-1));
    int c=((sCol<dCol)?(1):(-1));
    for(int i=1;sRow + i*r != dRow;i++){
        if(sq[sRow+i*r][sCol+i*c] != NULL){
            return false;
        }
    }
    if(sq[dRow][dCol]!=NULL){
        if(sq[dRow][dCol]->getColor()==color){
            return false;
        }
    }
    return true;
}

knight::knight(char colour, int p){
        player=p;
        color=colour;
        name='N';
        hasMoved=false;
    }
    bool getHasMoved(){
        return hasMoved;
}

void knight::moved(){
    hasMoved = true;
    return;
}

bool knight::validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
    if(!(((sCol-dCol)*(sRow-dRow)==2)||((sCol-dCol)*(sRow-dRow)==-2))){
        return false;
    }
    if(sq[dRow][dCol] != NULL)
        if(sq[dRow][dCol]->getColor() == color)
            return false;

    return true;
}

king::king(char colour, int p){
    name='K';
    color=colour;
    hasMoved=false;
    player=p;
    return;
}

bool king::getHasMoved(){
    return hasMoved;
}

void king::moved(){
    hasMoved=true;
    return;
}

bool king::validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
    if(dRow == 9)     //Castle
    {
        int playerTurn =((sRow==7)?(0):(1));
        if(dCol==0)     //Short Castle
        {
            if(!(sq[sRow][sCol+1]==NULL && sq[sRow][sCol+2]==NULL)){
                return false;
            }
            if(attack(playerTurn,sq,sRow,sCol)){
                return false;
            }
            if(attack(playerTurn,sq,sRow,sCol+1)){
                return false;
            }
            if(attack(playerTurn,sq,sRow,sCol+2)){
                return false;
            }
            if(hasMoved==true){
                return false;
            }
            if(sq[sRow][7]->getHasMoved()){     //Check if rook has moved
                return false;
            }
        }
        if(dCol==1)        //Long Castle
        {
            if(!(sq[sRow][sCol-1]==NULL && sq[sRow][sCol-2]==NULL &&sq[sRow][sCol-3]==NULL )){
                return false;
            }
            if(attack(playerTurn,sq,sRow,sCol)){
                return false;
            }
            if(attack(playerTurn,sq,sRow,sCol-1)){
                return false;
            }
            if(attack(playerTurn,sq,sRow,sCol-2)){
                return false;
            }
            if(hasMoved==true){
                return false;
            }
            if(sq[sRow][0]->getHasMoved()){     //Check if rook has moved
                return false;
            }
        }
    }
        else{
            if(!(((dRow-sRow)*(dCol-sCol)==1)||((dRow-sRow)*(dCol-sCol)==-1))){
                return false;
            }
            else
            if(sq[dRow][dCol] != NULL)
            {
                if(sq[dRow][dCol]->getColor() == color)
                    return false;
                else
                if(attack(player, sq, dRow, dCol))
                    return false;
            }
            else
            if(sq[dRow][dCol] == NULL)
            {
                if(attack(player, sq, dRow, dCol) == true)
                    return false;
            }
            return true;
        }
return true;
}

queen::queen(char colour, int p){
    name='Q';
    color=colour;
    player=p;
    hasMoved=false;
    //pp=p;
    return;
}

bool queen::getHasMoved(){
    return hasMoved;
}


void queen::moved(){
    hasMoved = true;
    return;
}

bool queen::validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
    rook r(color,player);
    bishop b(color,player);
    if((r.validate(sRow,sCol,dRow,dCol,sq))||(b.validate(sRow,sCol,dRow,dCol,sq))){
        return true;
    }
    return false;
}

pawn::pawn(char colour, int p){
    name='P';
    player=p;
    color=colour;
    hasMoved=false;
    return;
}
bool pawn::getHasMoved(){
    return hasMoved;
}


void pawn::moved(){
    hasMoved = true;
    return;
}

bool pawn::validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
    if(color == 'W')
    {
        if(sCol == dCol)
        {
            if(sq[sRow-1][sCol] == NULL && sRow-dRow == 1)
                return true;

            if((sq[sRow-2][sCol] == NULL) && (hasMoved == false)&& (sRow-dRow == 2))
                return true;

        }
        else if(sCol-dCol==1&&sRow-dRow==1){
            if(sq[sRow-1][sCol-1]==NULL){
                return false;
            }
            if(sq[sRow-1][sCol-1]->getColor()!=color){
                return true;
            }
        }
        else if(dCol-sCol==1&&sRow-dRow==1){
            if(sq[sRow-1][sCol+1]==NULL){
                return false;
            }
            if(sq[sRow-1][sCol+1]->getColor()!=color){
                return true;
            }
        }
        else{
            return false;
        }
    }
    if(color=='B'){
        if(sCol==dCol){
            if(sq[sRow+1][sCol]==NULL){
                if(sRow-dRow==-1){
                    return true;
                }
                if((sq[sRow+2][sCol]==NULL)&&(hasMoved==false)&&(sRow-dRow==-2)){
                    return true;
                }
            }
        }
        else if(sCol-dCol==1&&sRow-dRow==-1){
            if(sq[sRow+1][sCol-1]==NULL){
                return false;
            }
            if(sq[sRow+1][sCol-1]->getColor()!=color){
                return true;
            }
        }
        else if(dCol-sCol==1&&sRow-dRow==1){
            if(sq[sRow+1][sCol+1]==NULL){
                return false;
            }
            if(sq[sRow+1][sCol+1]->getColor()!=color){
                return true;
            }
        }
        else{
            return false;
        }
    }
    return false;
}
