#ifndef STRUCTURES_H
#define STRUCTURES_H

//#include <iostream>
using namespace std;

class piece
{
protected:
    char color;
    char name;
    int player;
    int code;
    int value;
    //int pTable[8][8];
public:
    int getPlayer(){
        return player;
    }
    char getColor(){
        return color;
    }
    char getName(){
        return name;
    }
    int getValue(){
        return value;
    }

    virtual int getPTable(int r, int c, piece *sq[8][8]) = 0;
    virtual bool validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]) = 0;
    virtual bool getHasMoved() = 0;
    virtual int getCode() = 0;
    virtual void moved() = 0;
    virtual int possibleMoves(int row, int col, piece *sq[8][8], int moveList[100][6], int moveNum) = 0;
};

bool attack(int playerTurn, piece *sq[8][8], int row, int col)
{
    for(int i = 0; i < 8; i++)
    {
        for(int j = 0; j < 8; j++)
        {
            if(sq[i][j] != NULL)
            {
                if(playerTurn != sq[i][j]->getPlayer())
                   {
                        if(sq[i][j]->validate(i, j, row, col, sq) == true && !(sq[i][j]->getName() == 'P' && j == col))
                        {
                            return true;
                        }
                   }
            }
        }
    }

    return false;
}

bool check(int playerTurn, piece *sq[8][8])
{
    for(int i = 0; i < 8; i++)
    {
        for(int j = 0; j < 8; j++)
        {
            if(sq[i][j] != NULL)
            {
                if(sq[i][j]->getPlayer() == playerTurn && sq[i][j]->getName() == 'K')
                {
                    if(attack(playerTurn, sq, i, j) != false)
                     {

                            return true;
                     }
                }
            }
        }
    }
    return false;
}

bool checkmate(int playerTurn, piece *sq[8][8])
{
    //cout<<"(cm)HERE";
    int moveList[100][6], moveNum = 0;
    for(int r = 0; r < 8; r++)
        for(int c = 0; c < 8; c++)
            if(sq[r][c] != NULL)
                if(sq[r][c]->getPlayer() == playerTurn)
                {
                    //cout<<"FT\n";
                    moveNum = sq[r][c]->possibleMoves(r, c, sq, moveList, moveNum);
                    //cout<<"Oh boy";
                    if(moveNum != 0)
                    {
                        //cout<<"F\n";
                        return false;
                    }
                }
    //cout<<"T\n";
    return true;
}

int sumPieceValues(piece *sq[8][8])
{
    int sumValues = 0;
    for(int i = 0; i < 8; i++)
        for(int j = 0; j < 8; j++)
         if(sq[i][j] != NULL)
            sumValues += sq[i][j]->getValue();

    return sumValues;
}

int max(int a, int b)
{
    return (a > b) ? a : b;
}

int min(int a, int b)
{
    return (a < b) ? a : b;
}

int findMin(int arr[], int n)
{
    int minVal = arr[0];
    for(int i = 1; i < n; i++)
        if(arr[i] < minVal)
            minVal = arr[i];

    return minVal;
}

int findMax(int arr[], int n)
{
    int maxVal = arr[0];
    for(int i = 1; i < n; i++)
        if(arr[i] > maxVal)
            maxVal = arr[i];

    return maxVal;
}

int mod(int a)
{
    return (a > 0) ? a : -a;
}
class rook : public piece{
protected:
       bool hasMoved;
public:

    int pTable[8][8]={{0,0,0,5,5,0,0,0},
                      {-5,0,0,0,0,0,0,-5},
                      {-5,0,0,0,0,0,0,-5},
                      {0,0,0,0,0,0,0,-5},
                      {0,0,0,0,0,0,0,-5},
                      {0,0,0,0,0,0,0,-5},
                      {5,10,10,10,10,10,10,5},
                      {0,0,0,0,0,0,0,0}};

    rook(char colour, int p){
        name='R';
        color=colour;
        hasMoved=false;
        player=p;
        code = 5;
        value=500;

        return;
    }

    int getPTable(int r, int c, piece *sq[8][8])
    {
        return pTable[r][c];
    }

    int getCode()
    {
        return code;
    }


    bool getHasMoved(){
        return hasMoved;
    }

    void moved(){
        hasMoved = true;
        return;
    }

    bool validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
        if(!(sRow==dRow||sCol==dCol)){
            return false;
        }
        if(sRow<dRow){
            for(int i=sRow+1;i<dRow;i++){
                if(!(sq[i][sCol]==NULL)){
                    return false;
                }
            }
        }
        else if(sRow>dRow){
            for(int i=dRow+1;i<sRow;i++){
                if(!(sq[i][sCol]==NULL)){
                    return false;
                }
            }
        }
        if(sCol<dCol){
            for(int i=sCol+1;i<dCol;i++){
                if(!(sq[sRow][i]==NULL)){
                    return false;
                }
            }
        }
        else if(dCol<sCol){
            for(int i=dCol+1;i<sCol;i++){
                if(!(sq[sRow][i]==NULL)){
                    return false;
                }
            }
        }
        if(sq[dRow][dCol] != NULL)
            if(sq[dRow][dCol]->getColor()==color)
                return false;

        return true;
    }

    int possibleMoves(int row, int col, piece *sq[8][8], int moveList[100][6], int moveNum)
    {
        //cout<<"In possMoves1\n";
        int addEntry[6];
        int currIndex = moveNum;
        int rMult, cMult, r, c;
        for(rMult = -1; rMult <= 1; rMult ++)
            for(cMult = -1; cMult <= 1; cMult ++)
            {
                if((rMult == 0 && cMult != 0) || (cMult == 0 && rMult != 0))
                {
                    r = row + rMult;
                    c = col + cMult;

                    while(r >= 0 && r <= 7 && c >= 0 && c <= 7)
                    {
                        if(validate(row, col, r, c, sq) == true)
                        {
                            piece *temp = sq[r][c];
                            sq[r][c] = sq[row][col];
                            sq[row][col] = NULL;

                            if(check(player, sq))
                            {
                                sq[row][col] = sq[r][c];
                                sq[r][c] = temp;
                                r += rMult;
                                c += cMult;
                                continue;
                            }
                            else
                            {
                                sq[row][col] = sq[r][c];
                                sq[r][c] = temp;
                                addEntry[0] = row;
                                addEntry[1] = col;
                                addEntry[2] = r;
                                addEntry[3] = c;
                                addEntry[4] = -1;
                                addEntry[5] = -1;

                            }

                            if(sq[r][c] != NULL)
                            {
                                addEntry[4] = sq[r][c]->getPlayer();
                                addEntry[5] = sq[r][c]->getCode();
                                for(int i = 0; i < 6; i++)
                                    moveList[currIndex][i] = addEntry[i];
                                currIndex++;
                                break;
                            }
                            else
                            {
                                for(int i = 0; i < 6; i++)
                                    moveList[currIndex][i] = addEntry[i];
                                currIndex++;
                            }
                        }

                        r += rMult;
                        c += cMult;

                    }
                }
            }
        return currIndex;
    }
};

class bishop : public piece{
protected:
       bool hasMoved;
public:

    int pTable[8][8]={{-20,-10,-10,-10,-10,-10,-10,-20},
                      {-10,5,0,0,0,0,5,-10},
                      {-10,10,10,10,10,10,10,-10},
                      {-10,0,10,10,10,10,0,-10},
                      {-10,5,5,10,10,5,5,-10},
                      {-10,0,5,10,10,5,0,-10},
                      {-10,0,0,0,0,0,0,-10},
                      {-20,-10,-10,-10,-10,-10,-10,-20}};
    bishop(char colour, int p){
        color=colour;
        name='B';
        hasMoved=false;
        player=p;
        code = 3;
        value = 330;
    }

    int getPTable(int r, int c, piece *sq[8][8])
    {
        return pTable[r][c];
    }

    bool getHasMoved(){
        return hasMoved;
    }

    int getCode()
    {
        return code;
    }

    void moved(){
        hasMoved = true;
        return;
    }

    bool validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
        if(!(((sRow-dRow)==(sCol-dCol))||((dRow-sRow)==(sCol-dCol)))){
            return false;
        }
        int r=((sRow<dRow)?(1):(-1));
        int c=((sCol<dCol)?(1):(-1));
        for(int i=1;sRow + i*r != dRow;i++){
            if(sq[sRow+i*r][sCol+i*c] != NULL){
                return false;
            }
        }
        if(sq[dRow][dCol]!=NULL){
            if(sq[dRow][dCol]->getColor()==color){
                return false;
            }
        }
    return true;
    }

    int possibleMoves(int row, int col, piece *sq[8][8], int moveList[100][6], int moveNum)
    {
        //cout<<"in Possmov2\n";
        int addEntry[6];
        int currIndex = moveNum;
        int rMult, cMult, r, c;

        //check diagonal moves
        for(rMult = -1; rMult <= 1; rMult += 2)
            for(cMult = -1; cMult <= 1; cMult += 2)
            {

                r = row + rMult;
                c = col + cMult;

                while(r >= 0 && r <= 7 && c >= 0 && c <= 7)
                {
                    if(validate(row, col, r, c, sq) == true)
                    {
                        piece *temp = sq[r][c];
                        sq[r][c] = sq[row][col];
                        sq[row][col] = NULL;

                        if(check(player, sq))
                        {
                            sq[row][col] = sq[r][c];
                            sq[r][c] = temp;

                            r += rMult;
                            c += cMult;
                            continue;
                        }
                        else
                        {
                            sq[row][col] = sq[r][c];
                            sq[r][c] = temp;
                            addEntry[0] = row;
                            addEntry[1] = col;
                            addEntry[2] = r;
                            addEntry[3] = c;
                            addEntry[4] = -1;
                            addEntry[5] = -1;

                        }

                        if(sq[r][c] != NULL)
                        {
                            addEntry[4] = sq[r][c]->getPlayer();
                            addEntry[5] = sq[r][c]->getCode();
                            for(int i = 0; i < 6; i++)
                                    moveList[currIndex][i] = addEntry[i];
                                currIndex++;
                            break;
                        }
                        else
                        {

                            for(int i = 0; i < 6; i++)
                                    moveList[currIndex][i] = addEntry[i];
                                currIndex++;
                        }
                    }

                    r += rMult;
                    c += cMult;
                }
            }

        return currIndex;
    }
};

class knight : public piece{
    protected:
       bool hasMoved;

    public:

    int pTable[8][8]={{-50,-40,-30,-30,-30,-30,-40,-50},
                      {-40,-20,0,5,5,0,-20,-40},
                      {-30,5,10,15,15,10,5,-30},
                      {-30,0,15,20,20,15,0,-30},
                      {-30,5,15,20,20,15,5,-30},
                      {-30,0,10,15,15,10,0,-30},
                      {-40,-20,0,0,0,0,-20,-40},
                      {-50,-40,-30,-30,-30,-30,-40,-50}};
        knight(char colour, int p){
            player=p;
            color=colour;
            name='N';
            hasMoved=false;
            code = 2;
            value=320;
        }

    int getPTable(int r, int c, piece *sq[8][8])
    {
        return pTable[r][c];
    }

    bool getHasMoved(){
            return hasMoved;
    }

    int getCode()
    {
        return code;
    }

    void moved(){
        hasMoved = true;
        return;
    }

    bool validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
        if(!(((sCol-dCol)*(sRow-dRow)==2)||((sCol-dCol)*(sRow-dRow)==-2))){
            return false;
        }
        if(sq[dRow][dCol] != NULL)
            if(sq[dRow][dCol]->getColor() == color)
                return false;

        return true;
    }

    int possibleMoves(int row, int col, piece *sq[8][8], int moveList[100][6], int moveNum)
    {
        //cout<<"In posmov 3\n";
        int addEntry[6];
        int currIndex = moveNum;
        int rDiff, cDiff, r, c;

        for(rDiff = -2; rDiff <= 2; rDiff += 1)
            for(cDiff = -2; cDiff <= 2; cDiff += 1)
            {
                if(rDiff*cDiff == 2 || rDiff*cDiff == -2)
                {
                    r = row + rDiff;
                    c = col + cDiff;

                    if(r >= 0 && r <= 7 && c >= 0 && c <= 7)
                    {
                        if(validate(row, col, r, c, sq) == true)
                        {
                            piece *temp = sq[r][c];
                            sq[r][c] = sq[row][col];
                            sq[row][col] = NULL;

                            if(check(player, sq))
                            {
                                sq[row][col] = sq[r][c];
                                sq[r][c] = temp;

                                continue;
                            }
                            else
                            {
                                sq[row][col] = sq[r][c];
                                sq[r][c] = temp;
                                addEntry[0] = row;
                                addEntry[1] = col;
                                addEntry[2] = r;
                                addEntry[3] = c;
                                addEntry[4] = -1;
                                addEntry[5] = -1;

                            }

                            if(sq[r][c] != NULL)
                            {
                                addEntry[4] = sq[r][c]->getPlayer();
                                addEntry[5] = sq[r][c]->getCode();
                            }
                                for(int i = 0; i < 6; i++)
                                    moveList[currIndex][i] = addEntry[i];
                                currIndex++;

                        }

                    }
                }
            }
        return currIndex;
    }
};



class king : public piece{
protected:
    bool hasMoved;

public:

    int pTable[8][8]={{20,30,10,0,0,10,30,20},
                    {20,20,0,0,0,0,20,20},
                    {-10,-20,-20,-20,-20,-20,-20,-10},
                    {-20,-30,-30,-40,-40,-30,-30,-20},
                    {-30,-40,-40,-50,-50,-40,-40,-30},
                    {-30,-40,-40,-50,-50,-40,-40,-30},
                    {-30,-40,-40,-50,-50,-40,-40,-30},
                    {-30,-40,-40,-50,-50,-40,-40,-30}};

    int endPTable[8][8] = {{-50,-30,-30,-30,-30,-30,-30,-50},
                            {-30,-30,0,0,0,0,-30,-30},
                            {-30,-10,20,30,30,20,-10,-30},
                            {-30,-10,30,40,40,30,-10,-30},
                            {-30,-10,30,40,40,30,-10,-30},
                            {-30,-10,20,30,30,20,-10,-30},
                            {-30,-20,-10,0,0,-10,-20,-30},
                            {-50,-40,-30,-20,-20,-30,-40,-50}};
    king(char colour, int p){
        name='K';
        color=colour;
        hasMoved=false;
        player=p;
        code = 0;
        value=20000;
        return;
    }


    int getPTable(int r, int c, piece *sq[8][8])
    {
        if(sumPieceValues(sq) > 43000)
            return pTable[r][c];
        else
            return endPTable[r][c];
    }

    bool getHasMoved(){
        return hasMoved;
    }

    int getCode()
    {
        return code;
    }

    void moved(){
        hasMoved=true;
        return;
    }

    bool validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
        if(dRow == 9)     //Castle
        {
            int playerTurn =((sRow==7)?(0):(1));
            if(dCol==0){
                if(!(sq[sRow][sCol+1]==NULL && sq[sRow][sCol+2]==NULL)){
                    return false;
                }
                if(attack(playerTurn,sq,sRow,sCol)){
                    return false;
                }
                if(attack(playerTurn,sq,sRow,sCol+1)){
                    return false;
                }
                if(attack(playerTurn,sq,sRow,sCol+2)){
                    return false;
                }
                if(hasMoved==true){
                    return false;
                }
                if(sq[sRow][7]==NULL){
                    return false;
                }
                if(sq[sRow][7]->getHasMoved()){
                    return false;
                }
            }
            if(dCol==1){
                if(!(sq[sRow][sCol-1]==NULL && sq[sRow][sCol-2]==NULL &&sq[sRow][sCol-3]==NULL )){
                    return false;
                }
                if(attack(playerTurn,sq,sRow,sCol)){
                    return false;
                }
                if(attack(playerTurn,sq,sRow,sCol-1)){
                    return false;
                }
                if(attack(playerTurn,sq,sRow,sCol-2)){
                    return false;
                }
                if(hasMoved==true){
                    return false;
                }
                if(sq[sRow][0]==NULL){
                    return false;
                }
                if(sq[sRow][0]->getHasMoved()){
                    return false;
                }
            }
        }
        else{
                if(!(((dRow-sRow)*(dCol-sCol)==1) ||
                ((dRow-sRow)*(dCol-sCol)==-1) ||
                ((dRow-sRow)*(dCol-sCol)==0 && mod(dRow-sRow) <= 1 && mod(dCol-sCol) <= 1)))
                {
                    return false;
                }
                else
                if(sq[dRow][dCol] != NULL)
                {
                    if(sq[dRow][dCol]->getColor() == color)
                        return false;
                }

                return true;
            }
    return true;
    }

    int possibleMoves(int row, int col, piece *sq[8][8], int moveList[100][6], int moveNum)
    {
        //cout<<"Ok here in posmov \n";
        int addEntry[6], currIndex = moveNum;
        for(int r = max(row-1, 0); r <= min(row+1,7);r++)
            for(int c = max(col-1, 0); c <= min(col+1,7); c++)
            {
                if((r != row || c != col))
                {
                    if(validate(row, col, r, c, sq) == true)
                    {
                        int t=r, u=c;
                        piece *temp = sq[r][c];
                        sq[r][c] = sq[row][col];
                        sq[row][col] = NULL;

                        if(check(player, sq))
                        {
                            sq[row][col] = sq[r][c];
                            sq[r][c] = temp;
                            continue;
                        }
                        else
                        {
                            sq[row][col] = sq[r][c];
                            sq[r][c] = temp;
                            addEntry[0] = row;
                            addEntry[1] = col;
                            addEntry[2] = r;
                            addEntry[3] = c;
                            addEntry[4] = -1;
                            addEntry[5] = -1;
                        }

                        if(sq[r][c] != NULL)
                        {
                            addEntry[4] = sq[r][c]->getPlayer();
                            addEntry[5] = sq[r][c]->getCode();
                        }

                        for(int i = 0; i < 6; i++)
                            moveList[currIndex][i] = addEntry[i];
                        currIndex++;
                        r = t;
                        c = u;
                    }
                }
            }
        //cout<<"Do we get here1? \n";
        if((row == 0 || row == 7) && col == 4)
        {
            //cout<<"Do we get here1? \n";
            if(validate(row, 4, 9, 1, sq) == true)        //Long Castle   //HERE LIES THE PROBLEM
            {
                addEntry[0] = row;
                addEntry[1] = 4;
                addEntry[2] = 9;
                addEntry[3] = 1;
                addEntry[4] = -1;
                addEntry[5] = -1;
                for(int i = 0; i < 6; i++)
                    moveList[currIndex][i] = addEntry[i];
                currIndex++;
            }
            if(validate(row, 4, 9, 0, sq) == true)        //Short Castle
            {
                addEntry[0] = row;
                addEntry[1] = 4;
                addEntry[2] = 9;
                addEntry[3] = 0;
                addEntry[4] = -1;
                addEntry[5] = -1;
                for(int i = 0; i < 6; i++)
                    moveList[currIndex][i] = addEntry[i];
                currIndex++;
            }
        }
        //cout<<"Do we get here2? \n";


        return currIndex;
    }

};

class queen:public piece{
protected:
    bool hasMoved;
public:
    //int pp;

        int pTable[8][8]={{-20,-10,-10,-5,-5,-10,-10,-20},
                          {-10,0,5,0,0,0,0,-10},
                          {-10,5,5,5,5,5,0,-10},
                          { 0 ,0,5,5,5,5,0,-5},
                          {-5,0,5,5,5,5,0,-5},
                          {-10,0,5,5,5,5,0,-10},
                          {-10,0,0,0,0,0,0,-10},
                          {-20,-10,-10,-5,-5,-10,-10,-20}};
    queen(char colour, int p){
        name='Q';
        color=colour;
        player=p;
        hasMoved=false;
        code = 9;
        value=900;
        return;
    }

    int getPTable(int r, int c, piece *sq[8][8])
    {
        return pTable[r][c];
    }

    bool getHasMoved(){
        return hasMoved;
    }

    int getCode()
    {
        return code;
    }

    void moved(){
        hasMoved = true;
        return;
    }

    bool validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
        rook r(color,player);
        bishop b(color,player);
        if((r.validate(sRow,sCol,dRow,dCol,sq))||(b.validate(sRow,sCol,dRow,dCol,sq))){
            return true;
        }
        return false;
    }

    int possibleMoves(int row, int col, piece *sq[8][8], int moveList[100][6], int moveNum)
    {
        int addEntry[6];
        int rMult, cMult, r, c, currIndex = moveNum;

        //check diagonal moves
        for(rMult = -1; rMult <= 1; rMult ++)
            for(cMult = -1; cMult <= 1; cMult ++)
            {
                if(rMult != 0 || cMult != 0)
                {
                    r = row + rMult;
                    c = col + cMult;

                    while(r >= 0 && r <= 7 && c >= 0 && c <= 7)
                    {
                        if(validate(row, col, r, c, sq) == true)
                        {
                            piece *temp = sq[r][c];
                            sq[r][c] = sq[row][col];
                            sq[row][col] = NULL;

                            if(check(player, sq))
                            {
                                sq[row][col] = sq[r][c];
                                sq[r][c] = temp;

                                r += rMult;
                                c += cMult;
                                continue;
                            }
                            else
                            {
                                sq[row][col] = sq[r][c];
                                sq[r][c] = temp;
                                addEntry[0] = row;
                                addEntry[1] = col;
                                addEntry[2] = r;
                                addEntry[3] = c;
                                addEntry[4] = -1;
                                addEntry[5] = -1;
                            }

                            if(sq[r][c] != NULL)
                            {
                                addEntry[4] = sq[r][c]->getPlayer();
                                addEntry[5] = sq[r][c]->getCode();
                                for(int i = 0; i < 6; i++)
                                    moveList[currIndex][i] = addEntry[i];
                                currIndex++;
                                break;
                            }
                            else
                            {
                                for(int i = 0; i < 6; i++)
                                    moveList[currIndex][i] = addEntry[i];
                                currIndex++;
                            }
                        }

                        r += rMult;
                        c += cMult;
                    }
                }
            }


        return currIndex;
    }

};

class pawn:public piece{
protected:
    bool hasMoved;
public:

        int pTable[8][8]={{0,0,0,0,0,0,0,0},
                          {5,10,10,-20,-20,10,10,5},
                          {5,-5,-10,0,0,-10,-5,5},
                          {0,0,0,20,20,0,0,0},
                          {5,5,10,25,25,10,5,5},
                          {10,10,20,30,30,20,10,10},
                          {50,50,50,50,50,50,50,50},
                          {900,900,900,900,900,900,900,900}};
    pawn(char colour, int p){
        name='P';
        player=p;
        color=colour;
        hasMoved=false;
        code = 1;
        value=100;
        return;
    }

    int getPTable(int r, int c, piece *sq[8][8])
    {
        return pTable[r][c];
    }

    bool getHasMoved(){
        return hasMoved;
    }


    int getCode()
    {
        return code;
    }

    void moved(){
        hasMoved = true;
        return;
    }

    bool validate(int sRow,int sCol, int dRow, int dCol, piece *sq[8][8]){
        if(color=='W'){
            if(sCol==dCol){
                if(sq[sRow-1][sCol]==NULL){
                    if(sRow-dRow==1){
                        return true;
                    }
                    if((sq[sRow-2][sCol]==NULL)&&(sRow == ((color=='W') ? 6 : 1))&&(sRow-dRow==2)){
                        return true;
                    }
                }
            }
            else if(sCol-dCol==1&&sRow-dRow==1){
                if(sq[sRow-1][sCol-1]==NULL){
                    return false;
                }
                if(sq[sRow-1][sCol-1]->getColor()!=color){
                    return true;
                }
            }
            else if(dCol-sCol==1&&sRow-dRow==1){
                if(sq[sRow-1][sCol+1]==NULL){
                    return false;
                }
                if(sq[sRow-1][sCol+1]->getColor()!=color){
                    return true;
                }
            }
            else{
                return false;
            }
        }
        else if(color=='B'){
            if(sCol==dCol){
                if(sq[sRow+1][sCol]==NULL){
                    if(sRow-dRow==-1){
                        return true;
                    }
                    if((sq[sRow+2][sCol]==NULL)&&(sRow == ((color=='W') ? 6 : 1))&&(sRow-dRow==-2)){
                        return true;
                    }
                }
            }
            else if(sCol-dCol==1&&sRow-dRow==-1){
                if(sq[sRow+1][sCol-1]==NULL){
                    return false;
                }
                if(sq[sRow+1][sCol-1]->getColor()!=color){
                    return true;
                }
            }
            else if(dCol-sCol==1&&sRow-dRow==-1){
                if(sq[sRow+1][sCol+1]==NULL){
                    return false;
                }
                if(sq[sRow+1][sCol+1]->getColor()!=color){
                    return true;
                }
            }
            else{
                return false;
            }
        }
        return false;
    }

    int possibleMoves(int row, int col, piece *sq[8][8], int moveList[100][6], int moveNum)
    {
        int addEntry[6];
        int mult = -1 + 2*player, r, c, currIndex = moveNum;

        for(c = col-1; c <= col+1; c++)
        {
            r = row+mult;

            if(r >= 0 && r <= 7 && c >= 0 && c <= 7)
            {
                if(validate(row, col, r, c, sq) == true)
                {
                    piece *temp = sq[r][c];
                    sq[r][c] = sq[row][col];
                    sq[row][col] = NULL;

                    if(check(player, sq))
                    {
                        sq[row][col] = sq[r][c];
                        sq[r][c] = temp;

                        continue;
                    }
                    else
                    {
                        sq[row][col] = sq[r][c];
                        sq[r][c] = temp;
                        addEntry[0] = row;
                        addEntry[1] = col;
                        addEntry[2] = r;
                        addEntry[3] = c;
                        addEntry[4] = -1;
                        addEntry[5] = -1;
                    }

                    if(sq[r][c] != NULL)
                    {
                        addEntry[4] = sq[r][c]->getPlayer();
                        addEntry[5] = sq[r][c]->getCode();
                        for(int i = 0; i < 6; i++)
                            moveList[currIndex][i] = addEntry[i];
                        currIndex++;
                    }
                    else
                    {
                        for(int i = 0; i < 6; i++)
                            moveList[currIndex][i] = addEntry[i];
                        currIndex++;
                    }
                }
            }
        }

        r = row + mult*2;
        if(r >= 0 && r <= 7)
        {
            if(validate(row, col, r, col, sq) == true)
            {
                piece *temp = sq[r][col];
                sq[r][col] = sq[row][col];
                sq[row][col] = NULL;

                if(check(player, sq) == false)
                {
                    addEntry[0] = row;
                    addEntry[1] = col;
                    addEntry[2] = r;
                    addEntry[3] = col;
                    addEntry[4] = -1;
                    addEntry[5] = -1;

                    for(int i = 0; i < 6; i++)
                        moveList[currIndex][i] = addEntry[i];
                    currIndex++;
                }

                sq[row][col] = sq[r][col];
                sq[r][col] = temp;



            }
        }

        return currIndex;
    }
};
#endif // STRUCTURES_H
